#version 450
// decals
struct PerFrameUniforms
{
    mat4 gViewMat4;
    mat4 gViewProjectionMat4;
    mat4 gCameraMat4;
    mat4 gCameraNoHeadTrackingMat4;
    mat4 gPrevViewProjectionMat4;
    mat4 gThisToPrevViewProjectionMat4;
    mat4 gInverseViewMat4;
    mat4 gInverseProjectionMat4;
    mat4 gInverseProjectionSCMat4;
    mat4 gInverseViewProjectionMat4;
    vec4 gInverseWorldUpMatVec4[3];
    vec3 gViewPositionVec3;
    float gfTime;
    vec3 gVREyeInfoVec3;
    float gfPrevTime;
    vec4 gClipPlanesVec4;
    vec4 gMBlurSettingsVec4;
    vec3 gDeJitterVec3;
    int giFrameIndex;
    vec4 gTaaSettingsVec4;
    vec4 gTessSettingsVec4;
    vec4 gShellsSettingsVec4;
    vec4 gFrameBufferSizeVec4;
    vec4 gFoVValuesVec4;
    vec4 gShadowSizeVec4;
    vec3 gShadowProjScaleVec3;
    int giDisableAmbientAllowed;
    vec4 gShadowFadeParamVec4;
};

struct CommonPerMeshUniforms
{
    vec4 gPlanetPositionVec4;
    mat4 gWorldMat4;
    mat4 gWorldNormalMat4;
    float gfFadeValue;
    vec4 gLightColourVec4;
    vec4 gLightCustomParamsVec4;
    mat4 gWorldMotionMat4;
    mat4 gInverseModelMat4;
};

struct CustomPerMaterialUniforms
{
    vec4 gImposterDataVec4;
    vec4 gTileBlendScalesVec4;
    vec4 gHueOverlayParamsVec4;
    vec4 gSaturationOverlayParamsVec4;
    vec4 gValueOverlayParamsVec4;
    vec4 gTerrainColour1Vec4;
    vec4 gTerrainColour2Vec4;
    vec4 gMaterialParamsVec4;
    vec4 gMaterialColourVec4;
    vec4 gMaterialSFXVec4;
    vec4 gMaterialSFXColVec4;
    vec4 gSunPositionVec4;
};

struct CustomPerMeshUniforms
{
    vec4 gUVScrollStepVec4;
    vec4 gCustomParams01Vec4;
    vec4 gCustomParams02Vec4;
    vec4 gObjectColourVec4;
};

struct UniformBuffer
{
    PerFrameUniforms mpPerFrame;
    CommonPerMeshUniforms mpCommonPerMesh;
    CustomPerMaterialUniforms mpCustomPerMaterial;
    CustomPerMeshUniforms mpCustomPerMesh;
};

//Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
layout(set = 0, binding = 45, std140) uniform Vk3DParams
{
    vec4 stereo;
    vec4 custom_params;
} vk3d_params;

layout(set = 0, binding = 0, std140) uniform lUniforms_BLK
{
    UniformBuffer lUniforms;
} _507;

layout(set = 1, binding = 2) uniform sampler2D gFadeNoiseMap;
layout(set = 1, binding = 3) uniform sampler2D gBufferMap;
layout(set = 1, binding = 0) uniform sampler2D gDiffuseMap;
layout(set = 1, binding = 1) uniform sampler2D gMasksMap;

layout(location = 0) in VertexBlock
{
    vec4 mTexCoordsVec4;
    vec4 mWorldPositionVec3_mfSpare;
    vec3 mTangentSpaceNormalVec3;
    vec4 mScreenSpacePositionVec4;
    flat vec3 mfFadeValueForInstance_mfLodIndex_mfShearMotionLength;
} In;

layout(location = 0) out vec4 out_color0;
layout(location = 1) out vec4 out_color1;
layout(location = 2) out vec4 out_color2;
layout(location = 3) out vec4 out_color3;

vec4 _1301;

void main()
{
    if (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x < 1.0)
    {
        vec3 _905 = floor(In.mWorldPositionVec3_mfSpare.xyz);
        vec3 _907 = fract(In.mWorldPositionVec3_mfSpare.xyz);
        vec4 _927 = textureLod(gFadeNoiseMap, (_905.xy + (vec2(37.0, 17.0) * _905.z)) + ((_907 * _907) * (vec3(3.0) - (_907 * 2.0))).xy, 0.0);
        float _928 = _927.x;
        if (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x < 0.0)
        {
            if ((1.0 - _928) > (In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x + 2.0))
            {
                discard;
            }
        }
        else
        {
            if (_928 > In.mfFadeValueForInstance_mfLodIndex_mfShearMotionLength.x)
            {
                discard;
            }
        }
    }
    vec2 _969 = ((In.mScreenSpacePositionVec4.xy / vec2(In.mScreenSpacePositionVec4.w)) * 0.5) + vec2(0.5);
    vec2 _1072 = (_969 * 2.0) - vec2(1.0);
    vec4 _1265 = vec4(_1072.x, _1072.y, _1301.z, _1301.w);
    _1265.z = (((_507.lUniforms.mpPerFrame.gClipPlanesVec4.x * _507.lUniforms.mpPerFrame.gClipPlanesVec4.y) / (texture(gBufferMap, vec2(_969.x, 1.0 - _969.y)).x * _507.lUniforms.mpPerFrame.gClipPlanesVec4.y)) - _507.lUniforms.mpPerFrame.gClipPlanesVec4.x) / (_507.lUniforms.mpPerFrame.gClipPlanesVec4.y - _507.lUniforms.mpPerFrame.gClipPlanesVec4.x);
    
    _1265.x -= vk3d_params.stereo.x * (1 - vk3d_params.stereo.y * _1265.z * 10);
    
    vec4 _1267 = _1265;
    _1267.w = 1.0;
    vec4 _1082 = _507.lUniforms.mpPerFrame.gInverseViewProjectionMat4 * _1267;
    vec3 _998 = (_507.lUniforms.mpCommonPerMesh.gInverseModelMat4 * vec4((_1082.xyz / vec3(_1082.w)).xyz + _507.lUniforms.mpPerFrame.gViewPositionVec3, 1.0)).xyz + vec3(0.5);
    float _1001 = 1.0 - _998.y;
    vec3 _1271 = _998;
    _1271.y = _1001;
    float _1004 = _998.x;
    bool _1005 = _1004 < 0.0;
    bool _1012;
    if (!_1005)
    {
        _1012 = _1004 >= 1.0;
    }
    else
    {
        _1012 = _1005;
    }
    bool _1019;
    if (!_1012)
    {
        _1019 = _1001 < 0.0;
    }
    else
    {
        _1019 = _1012;
    }
    bool _1026;
    if (!_1019)
    {
        _1026 = _1001 >= 1.0;
    }
    else
    {
        _1026 = _1019;
    }
    bool _1033;
    if (!_1026)
    {
        _1033 = _998.z < 0.0;
    }
    else
    {
        _1033 = _1026;
    }
    bool _1040;
    if (!_1033)
    {
        _1040 = _998.z >= 1.0;
    }
    else
    {
        _1040 = _1033;
    }
    if (_1040)
    {
        discard;
    }
    vec4 _629 = texture(gDiffuseMap, _1271.xy);
    vec4 _635 = texture(gMasksMap, _1271.xy);
    float _637 = _629.w;
    if (_637 < 0.449999988079071044921875)
    {
        discard;
    }
    vec4 _1286 = _1301;
    _1286.x = 0.0;
    vec4 _1288 = _1286;
    _1288.y = sqrt(((1.0 - _635.y) * _507.lUniforms.mpCustomPerMaterial.gMaterialParamsVec4.x) * 0.5);
    vec4 _1290 = _1288;
    _1290.z = clamp(_507.lUniforms.mpCustomPerMaterial.gMaterialParamsVec4.z, 0.0, 1.0);
    vec4 _1292 = _1290;
    _1292.w = 0.0;
    out_color0 = vec4(_629.xyz, smoothstep(0.449999988079071044921875, 0.800000011920928955078125, _637));
    out_color1 = vec4(0.0);
    out_color2 = vec4(0.0);
    out_color3 = _1292;
}


